#!/usr/bin/php
<?php
if (isset($_SERVER['REMOTE_ADDR'])) {
    die('Direct access not permitted');
}
// This script will output a meterN compatible format for the main command
// You'll need to setup the path to meterN ($pathtomn). 
// ln -s /var/www/comapps/pooler.php /usr/bin/pooler
// Usage:  pooler [MeterID] [SubMeterID]

$pathtomn = '/var/www/metern';

//
// No edit should be needed bellow
//
// -----------------------------------------------------------------------------
if (isset($_SERVER['REMOTE_ADDR'])) {
    die('Direct access not permitted');
}

if (!isset($argv[1], $argv[2], $argv[3])) {
	$argv[1] = null;
}

if ($argv[1] != null && $argv[2] != null && ($argv[3] == 'power' || $argv[3] == 'energy')) {
	$metnum = $argv[1];		// Meter ID 
	$submetnum = $argv[2];	// Submeter 

	$cmd = "more /dev/shm/metern$metnum.txt | egrep \"^" . $metnum . "_" . $submetnum . "\(\" | grep \")\""; 
    #echo "$cmd\n";

	define('checkaccess', TRUE);
	include("$pathtomn/config/config_main.php");
	include("$pathtomn/config/memory.php");
	include("$pathtomn/config/config_met$metnum.php");

	if ($argv[3] == 'energy') {
		///// open mN shm memory
		$data = file_get_contents($MEMORY);
		$memarray = json_decode($data, true);

		// retrive meter's previus value
		if (isset($memarray["Totalcounter$metnum"])) {
			$prevvalue = $memarray["Totalcounter$metnum"];
		} else {
			$prevvalue = null;
		}

		// Now retrieve the current value
		$datareturn = shell_exec($cmd);
		#echo "$datareturn";
		$datareturn = trim($datareturn);
		$datareturn = preg_replace("/^${'ID'.$metnum}\(/i", '', $datareturn); // VALUE*UNIT)
		$lastval = preg_replace("/\*[a-z0-9]+\)$/i", '', $datareturn); // VALUE
#		echo "$lastval\n";

		settype($lastval, 'float');
		settype($prevvalue, 'float');

		// controlla se il contatore segna meno del valore precedente
		if ($lastval < $prevvalue) { 
			$lastval = $prevvalue;
		}
	
		$lastval = round($lastval, ${'PRECI' . $metnum});
		$str = utf8_decode("${'ID'.$metnum}($lastval*${'UNIT'.$metnum})\n");
		file_put_contents("/dev/shm/consumi$metnum.txt", $str);
		echo "$str";
	}
	
	if ($argv[3] == 'power') {
		$datareturn = trim(shell_exec($cmd));
		$datareturn = preg_replace("/^${'LID'.$metnum}\(/i", '', $datareturn); // VALUE*UNIT)
		$lastval = preg_replace("/\*[a-z0-9]+\)$/i", '', $datareturn); // VALUE
		
		settype($lastval, 'float');
		$lastval = round($lastval, ${'PRECI' . $metnum});
		$str = utf8_decode("${'LID'.$metnum}($lastval*${'LIVEUNIT'.$metnum})\n");
		echo "$str";
	}
} else {
	die("Usage: pooler {MeterID} {SubMeterID} {energy|power}\n");
}
?>
